#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int N, M;
vector<int> typy;
vector< vector<int> > teleporty;
vector<bool> bezpecne, znesitelne;

bool je_bezpecna(int start) { 
    vector<bool> navstivil(N+1,false);
    queue<int> Q;
    navstivil[start] = true;
    Q.push(start);
    while (!Q.empty()) {
        int kde = Q.front(); Q.pop();
        if (typy[kde] != 2) return false;
        for (unsigned i=0; i<teleporty[kde].size(); ++i) {
            int kam = teleporty[kde][i];
            if (navstivil[kam]) continue;
            navstivil[kam] = true;
            Q.push(kam);
        }
    }
    return true;
}

bool je_znesitelna(int start) { 
    vector<bool> navstivil(N+1,false);
    queue<int> Q;
    navstivil[start] = true;
    Q.push(start);
    while (!Q.empty()) {
        int kde = Q.front(); Q.pop();
        if (typy[kde] == 0) continue;
        if (bezpecne[kde]) return true;
        for (unsigned i=0; i<teleporty[kde].size(); ++i) {
            int kam = teleporty[kde][i];
            if (navstivil[kam]) continue;
            navstivil[kam] = true;
            Q.push(kam);
        }
    }
    return false;
}

int main() {
    cin >> N >> M;
    typy.resize(N+1);
    for (int n=1; n<=N; ++n) cin >> typy[n];
    teleporty.resize(N+1);
    while (M--) {
        int x, y;
        cin >> x >> y;
        teleporty[x].push_back(y);
    }

    bezpecne.resize(N);
    znesitelne.resize(N,false);
    for (int n=1; n<=N; ++n) bezpecne[n] = je_bezpecna(n);
    for (int n=1; n<=N; ++n) if (!bezpecne[n]) znesitelne[n] = je_znesitelna(n);

    // vypis vysledku
    cout << "bezpecne:";
    for (int n=1; n<=N; ++n) if (bezpecne[n]) cout << " " << n;
    cout << endl << "snesitelne:";
    for (int n=1; n<=N; ++n) if (znesitelne[n]) cout << " " << n;
    cout << endl;
}
