#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int N, M;
vector<int> typy;
vector< vector<int> > teleporty;

vector<bool> prehladaj(const vector<int> start, bool moze0) {
    vector<bool> navstivil(N+1,false);
    queue<int> Q;
    for (unsigned i=0; i<start.size(); ++i) {
        navstivil[ start[i] ] = true;
        Q.push( start[i] );
    }
    while (!Q.empty()) {
        int kde = Q.front(); Q.pop();
        for (unsigned i=0; i<teleporty[kde].size(); ++i) {
            int kam = teleporty[kde][i];
            if (!moze0 && typy[kam]==0) continue;
            if (navstivil[kam]) continue;
            navstivil[kam] = true;
            Q.push(kam);
        }
    }
    return navstivil;
}

int main() {
    cin >> N >> M;
    typy.resize(N+1);
    for (int n=1; n<=N; ++n) cin >> typy[n];
    teleporty.resize(N+1);
    while (M--) {
        int x, y;
        cin >> x >> y;
        teleporty[y].push_back(x);
    }

    // prve prehladavanie: z planet typu 0 a 1 cez cokolvek
    vector<int> start1;
    for (int n=1; n<=N; ++n) if (typy[n]<2) start1.push_back(n);
    vector<bool> nebezpecne = prehladaj(start1,true);

    // druhe prehladavanie: z bezpecnych planet cez typ 1 a 2
    vector<int> start2;
    for (int n=1; n<=N; ++n) if (!nebezpecne[n]) start2.push_back(n);
    vector<bool> znesitelne = prehladaj(start2,false);
    
    // vypis vysledku
    cout << "bezpecne:";
    for (int n=1; n<=N; ++n) if (!nebezpecne[n]) cout << " " << n;
    cout << endl << "snesitelne:";
    for (int n=1; n<=N; ++n) if (nebezpecne[n] && znesitelne[n]) cout << " " << n;
    cout << endl;
}
